﻿using System;

using Winnovative;

namespace HtmlToPdfNetCoreDemo
{
    class Program
    {
        static void Main(string[] args)
        {
            // register code pages for text before running the converter
            System.Text.Encoding.RegisterProvider(System.Text.CodePagesEncodingProvider.Instance);

            string urlToConvert = "http://www.google.com";

            // parse arguments
            if (args.Length > 0)
                urlToConvert = args[0];

            // convert HTML to PDF
            try
            {
                // create the HTML to PDF converter object
                HtmlToPdfConverter htmlToPdfConverter = new HtmlToPdfConverter();

                // set license key
                htmlToPdfConverter.LicenseKey = "fvDh8eDx4fHg4P/h8eLg/+Dj/+jo6Og=";

                // Set an adddional delay in seconds to wait for JavaScript or AJAX calls after page load completed
                // Set this property to 0 if you don't need to wait for such asynchcronous operations to finish
                htmlToPdfConverter.ConversionDelay = 2;

                // set PDF page size
                htmlToPdfConverter.PdfDocumentOptions.PdfPageSize = PdfPageSize.A4;

                // set PDF page orientation
                htmlToPdfConverter.PdfDocumentOptions.PdfPageOrientation = PdfPageOrientation.Portrait;

                // convert the HTML page from given URL to PDF in a buffer
                byte[] pdfBytes = htmlToPdfConverter.ConvertUrl(urlToConvert);

                // write the PDF buffer in output file
                System.IO.File.WriteAllBytes("WnvHtmlToPdf.pdf", pdfBytes);

                Console.WriteLine("Conversion succeeded. Please check the output folder.");
            }
            catch (Exception ex)
            {
                Console.WriteLine(String.Format("Error: {0}", ex.Message));
            }
        }
    }
}
